<template>
  <v-slider
    v-model="model"
    hide-details
    :step="step"
    :color="color"
    :min="min"
    :max="max"
    :disabled="disabled"
    :show-ticks="showTicks ? 'always' : false"
    :thumb-label="thumbLabel ? 'always' : false"
    @update:model-value="update"
  >
    <template #thumb-label>
      {{ parseInt(model) }}
    </template>
  </v-slider>
</template>

<script setup>
import { ref, watch, onMounted } from "vue";

const emit = defineEmits(['update:modelValue']);

onMounted(() => {
  model.value = props?.modelValue;
});

const model = ref(null);

const props = defineProps({
  modelValue: {
    type: Number,
    default: 0
  },
  step: {
    type: Number,
    default: 0,
  },
  min: {
    type: Number,
    default: 0,
  },
  max: {
    type: Number,
    default: 100,
  },
  color: {
    type: String,
    default: 'primary',
  },
  disabled: {
    type: Boolean,
    default: false,
  },
  thumbLabel: {
    type: Boolean,
    default: false,
  },
  showTicks: {
    type: Boolean,
    default: false,
  },
});

const update = (value) => {
  emit('update:modelValue', value);
}

watch(props, (newValue, oldValue) => {
  if (newValue?.modelValue) {
    model.value = newValue?.modelValue;
  }
})
</script>